# coding: utf-8

"""
    CyberSource Merged Spec

    All CyberSource API specs merged together. These are available at https://developer.cybersource.com/api/reference/api-reference.html

    OpenAPI spec version: 0.0.1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

from pprint import pformat
from six import iteritems
import re


class Ptsv2paymentsSenderInformationAccount(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """


    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'number': 'str',
        'type': 'str',
        'funds_source': 'str'
    }

    attribute_map = {
        'number': 'number',
        'type': 'type',
        'funds_source': 'fundsSource'
    }

    def __init__(self, number=None, type=None, funds_source=None):
        """
        Ptsv2paymentsSenderInformationAccount - a model defined in Swagger
        """

        self._number = None
        self._type = None
        self._funds_source = None

        if number is not None:
          self.number = number
        if type is not None:
          self.type = type
        if funds_source is not None:
          self.funds_source = funds_source

    @property
    def number(self):
        """
        Gets the number of this Ptsv2paymentsSenderInformationAccount.
        The account number of the entity funding the transaction. The value for this field can be a payment card account number or bank account number. 

        :return: The number of this Ptsv2paymentsSenderInformationAccount.
        :rtype: str
        """
        return self._number

    @number.setter
    def number(self, number):
        """
        Sets the number of this Ptsv2paymentsSenderInformationAccount.
        The account number of the entity funding the transaction. The value for this field can be a payment card account number or bank account number. 

        :param number: The number of this Ptsv2paymentsSenderInformationAccount.
        :type: str
        """

        self._number = number

    @property
    def type(self):
        """
        Gets the type of this Ptsv2paymentsSenderInformationAccount.
        Identifies the sender's account type. This field is applicable for AFT transactions.  Valid values are:   - `00` for Other   - `01` for Routing Transit Number (RTN) + Bank Account Number (BAN)   - `02` for International Bank Account Number (IBAN)   - `03` for Card Account   - `04` for Email   - `05` for Phone Number   - `06` for Bank Account Number (BAN) + Bank Identification Code (BIC), also known as a SWIFT code   - `07` for Wallet ID   - `08` for Social Network ID 

        :return: The type of this Ptsv2paymentsSenderInformationAccount.
        :rtype: str
        """
        return self._type

    @type.setter
    def type(self, type):
        """
        Sets the type of this Ptsv2paymentsSenderInformationAccount.
        Identifies the sender's account type. This field is applicable for AFT transactions.  Valid values are:   - `00` for Other   - `01` for Routing Transit Number (RTN) + Bank Account Number (BAN)   - `02` for International Bank Account Number (IBAN)   - `03` for Card Account   - `04` for Email   - `05` for Phone Number   - `06` for Bank Account Number (BAN) + Bank Identification Code (BIC), also known as a SWIFT code   - `07` for Wallet ID   - `08` for Social Network ID 

        :param type: The type of this Ptsv2paymentsSenderInformationAccount.
        :type: str
        """

        self._type = type

    @property
    def funds_source(self):
        """
        Gets the funds_source of this Ptsv2paymentsSenderInformationAccount.
        Source of funds. Possible Values:  - `01`: Credit.  - `02`: Debit.  - `03`: Prepaid.  - `04`: Deposit Account.  - `05`: Mobile Money Account.  - `06`: Cash.  - `07`: Other.  - `V5`: Debits / deposit access other than those linked to the cardholders' scheme.  - `V6`: Credit accounts other than those linked to the cardholder's scheme. 

        :return: The funds_source of this Ptsv2paymentsSenderInformationAccount.
        :rtype: str
        """
        return self._funds_source

    @funds_source.setter
    def funds_source(self, funds_source):
        """
        Sets the funds_source of this Ptsv2paymentsSenderInformationAccount.
        Source of funds. Possible Values:  - `01`: Credit.  - `02`: Debit.  - `03`: Prepaid.  - `04`: Deposit Account.  - `05`: Mobile Money Account.  - `06`: Cash.  - `07`: Other.  - `V5`: Debits / deposit access other than those linked to the cardholders' scheme.  - `V6`: Credit accounts other than those linked to the cardholder's scheme. 

        :param funds_source: The funds_source of this Ptsv2paymentsSenderInformationAccount.
        :type: str
        """

        self._funds_source = funds_source

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if not isinstance(other, Ptsv2paymentsSenderInformationAccount):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other
